/**
 * BLOCK: Base Accordion
 */
import classnames from 'classnames';

import {
	InnerBlocks,
	useBlockProps,
} from '@wordpress/block-editor';

function BaseAccordionSave( { attributes } ) {

	const { uniqueID, paneCount, align, maxWidth, titleAlignment, startCollapsed, linkPaneCollapse, showIcon, iconStyle, iconSide, openPane } = attributes;
	const classes = classnames( `align${( align ? align : 'none' )}` );
	const innerClasses = classnames( `bt-accordion-wrap bt-accordion-id${uniqueID} bt-accordion-has-${paneCount}-panes bt-active-pane-${openPane} bt-accordion-block bt-pane-header-alignment-${ titleAlignment ? titleAlignment : 'left' } bt-accodion-icon-style-${( iconStyle && showIcon ? iconStyle : 'none' )} bt-accodion-icon-side-${( iconSide ? iconSide : 'right' )}` );

	const blockProps = useBlockProps.save( {
		className: classes,
	} );

	return (
		<div {...blockProps}>
			<div className={innerClasses} style={{
				maxWidth: ( maxWidth ? maxWidth + 'px' : 'none' ),
			}}>
				<div className="bt-accordion-inner-wrap" data-allow-multiple-open={( !linkPaneCollapse ? 'true' : 'false' )} data-start-open={( !startCollapsed ? openPane : 'none' )}>
					<InnerBlocks.Content/>
				</div>
			</div>
		</div>
	);

}

export default BaseAccordionSave;
