import { __ } from '@wordpress/i18n';
import {
	TextControl,
	PanelRow,
	RangeControl
} from '@wordpress/components';

export default function MessageOptions( { setAttributes, messages } ) {

	const saveMessages = ( value ) => {
		setAttributes( {  ...messages, ...value }, 'messages' );
	};

	return (
		<>
			<TextControl
				label={__( 'Success Message', 'gutenam-blocks' )}
				placeholder={__( 'Submission Success, Thanks for getting in touch!', 'gutenam-blocks' )}
				value={( undefined !== messages.success ? messages.success : '' )}
				onChange={( value ) => saveMessages( { success: value } )}
			/>
			<TextControl
				label={__( 'Pre Submit Form Validation Error Message', 'gutenam-blocks' )}
				placeholder={__( 'Please fix the errors to proceed', 'gutenam-blocks' )}
				value={( undefined !== messages.preError ? messages.preError : '' )}
				onChange={( value ) => saveMessages( { preError: value } )}
			/>
			<TextControl
				label={__( 'Error Message', 'gutenam-blocks' )}
				placeholder={__( 'Submission Failed', 'gutenam-blocks' )}
				value={( undefined !== messages.error ? messages.error : '' )}
				onChange={( value ) => saveMessages( { error: value } )}
			/>
		</>
	);

}
