import { __ } from '@wordpress/i18n';
import Select from 'react-select';
import { applyFilters } from '@wordpress/hooks';

export default function SubmitActionOptions( { setAttributes, selectedActions } ) {

	const actionOptionsList = [
		{ value: 'email', label: __( 'Email', 'gutenam-blocks' ), help: '', isDisabled: false },
		{ value: 'redirect', label: __( 'Redirect', 'gutenam-blocks' ), help: '', isDisabled: false },
		{ value: 'mailerlite', label: __( 'Mailerlite', 'gutenam-blocks' ), help: __( 'Add User to MailerLite list', 'gutenam-blocks' ), isDisabled: false },
		{ value: 'fluentCRM', label: __( 'FluentCRM', 'gutenam-blocks' ), help: __( 'Add User to FluentCRM list', 'gutenam-blocks' ), isDisabled: false },
		{ value: 'convertkit', label: __( 'ConvertKit (Pro addon)', 'gutenam-blocks' ), help: __( 'Add user to ConvertKit', 'gutenam-blocks' ), isDisabled: true },
		{ value: 'activecampaign', label: __( 'ActiveCampaign (Pro addon)', 'gutenam-blocks' ), help: __( 'Add user to ActiveCampaign', 'gutenam-blocks' ), isDisabled: true },
		{ value: 'autoEmail', label: __( 'Auto Respond Email (Pro addon)', 'gutenam-blocks' ), help: __( 'Send instant response to form entrant', 'gutenam-blocks' ), isDisabled: true },
		{ value: 'entry', label: __( 'Database Entry (Pro addon)', 'gutenam-blocks' ), help: __( 'Log each form submission', 'gutenam-blocks' ), isDisabled: true  },
		{ value: 'sendinblue', label: __( 'Brevo (SendInBlue) (Pro addon)', 'gutenam-blocks' ), help: __( 'Add user to Brevo list', 'gutenam-blocks' ), isDisabled: true },
		{ value: 'mailchimp', label: __( 'MailChimp (Pro addon)', 'gutenam-blocks' ), help: __( 'Add user to MailChimp list', 'gutenam-blocks' ), isDisabled: true },
		{ value: 'webhook', label: __( 'WebHook (Pro addon)', 'gutenam-blocks' ), help: __( 'Send form information to any third party webhook', 'gutenam-blocks' ), isDisabled: true },
	];

	const filteredOptions = applyFilters( 'base.actionOptionsAdvancedForm', actionOptionsList );
	const selectedOptions = filteredOptions.filter( ( item ) => selectedActions.includes( item.value ) );

	return (
		<Select
			className={ 'bb-adv-form-actions' }
			isMulti={true}
			value={ selectedOptions }
			onChange={ ( selections ) => {
				const valuesOnly = selections.map( ( item ) => {
					return item.value
				} );
				setAttributes( valuesOnly, 'actions' );
			} }
			options={ filteredOptions }
		/>
	);

}
