/**
 * External dependencies
 */
import { captchaIcon } from '@base/icons';

/**
 * Internal dependencies
 */
import edit from './edit';
import metadata from './block.json';
import { registerBlockType } from '@wordpress/blocks';

/**
 * WordPress dependencies
 */
import { __ } from '@wordpress/i18n';

registerBlockType('base/advanced-form-captcha', {
	...metadata,
	title: __( 'Captcha', 'gutenam-blocks' ),
	description: __( 'Base Form Captcha Block', 'gutenam-blocks' ),
	keywords: [
		'captcha',
		'verify',
		'bot'
	],
	ancestor: [ 'base/advanced-form' ],
	parent: [ 'base/advanced-form', 'base/column' ],
	icon: {
		src: captchaIcon,
	},
	edit,
	save: () => null,

});
