/**
 * External dependencies
 */
import { advancedBtnIcon } from '@base/icons';

/**
 * Internal dependencies
 */
import edit from './edit';
import metadata from './block.json';
import { registerBlockType } from '@wordpress/blocks';

/**
 * WordPress dependencies
 */
import { __ } from '@wordpress/i18n';
import { Icon } from '@wordpress/components';

registerBlockType('base/advanced-form-submit', {
	...metadata,
	title: __( 'Submit Button', 'gutenam-blocks' ),
	description: __( 'Base Form Submit Button', 'gutenam-blocks' ),
	keywords: [
		'submit',
		'button',
		'send'
	],
	ancestor: [ 'base/advanced-form' ],
	parent: [ 'base/advanced-form', 'base/column' ],
	icon: {
		src: advancedBtnIcon,
	},
	edit,
	save: () => null,

});
