import { registerBlockType } from '@wordpress/blocks';
import { __ } from '@wordpress/i18n';

import { formBlockIcon } from '@base/icons';

import './fields/submit/style.scss';
import './style.scss';
import './fields/accept/index';
import './fields/captcha/index';
import './fields/checkbox/index';
import './fields/date/index';
import './fields/email/index';
import './fields/file/index';
import './fields/hidden/index';
import './fields/number/index';
import './fields/radio/index';
import './fields/select/index';
import './fields/submit/index';
import './fields/telephone/index';
import './fields/text/index';
import './fields/textarea/index';
import './fields/time/index';

/**
 * Internal dependencies
 */
import edit from './edit';
import metadata from './block.json';

import { InnerBlocks } from '@wordpress/block-editor';
import transforms from './transforms';


registerBlockType( 'base/advanced-form', {
	...metadata,
	title: __( 'Form (Adv)', 'gutenam-blocks' ),
	description: __( 'Create an advanced contact or marketing form for your website.', 'gutenam-blocks' ),
	keywords: [
		__( 'contact', 'gutenam-blocks' ),
		__( 'form', 'gutenam-blocks' ),
		'bb',
	],
	icon: {
		src: formBlockIcon,
	},
	transforms,
	edit,
	save:() => {
		return <InnerBlocks.Content />;
	}
});
