/**
 * External dependencies
 */
import { __ } from '@wordpress/i18n';
import { RichText } from '@wordpress/block-editor';

const FormFieldLabel = ( { setAttributes, label, showLabel, required } ) => {

	if( !showLabel ){
		return (
			<></>
		);
	}

	return (
		<div className={'bb-adv-form-label'}>
				<RichText
					onChange={( value ) => {
						setAttributes( { label: value } );
					}}
					placeholder={__( 'Field label', 'gutenam-blocks' )}
					allowedFormats={ [ 'core/bold', 'core/italic', 'core/link', 'core/underline' ] }
					tagName="label"
					value={label}
					multiline={ false }
				/>
				{ required && <span className={ 'bb-adv-form-required' }>*</span>}
		</div>
	);
};

export default FormFieldLabel;
