/**
 * BLOCK: Base Spacer
 */

import {
	useBlockProps,
	InnerBlocks
} from '@wordpress/block-editor';
/**
 * External dependencies
 */
import { BaseColorOutput } from '@base/helpers';
import { times } from 'lodash';

function Save( { attributes } ) {
	const { items, listCount, columns, blockAlignment, iconAlign, uniqueID, tabletColumns, mobileColumns } = attributes;

	const blockProps = useBlockProps.save( {
		className: `wp-block-base-iconlist bt-svg-icon-list-items bt-svg-icon-list-items${ uniqueID } bt-svg-icon-list-columns-${ columns } align${ ( blockAlignment ? blockAlignment : 'none' ) }${ ( undefined !== iconAlign && 'middle' !== iconAlign ? ' bt-list-icon-align' + iconAlign : '' ) }${ ( undefined !== tabletColumns && '' !== tabletColumns ? ' bt-tablet-svg-icon-list-columns-' + tabletColumns : '' ) }${ ( undefined !== mobileColumns && '' !== mobileColumns ? ' bt-mobile-svg-icon-list-columns-' + mobileColumns : '' ) }`
	} );

	return (
		<div {...blockProps}>
			<ul className="bt-svg-icon-list">
				<InnerBlocks.Content/>
			</ul>
		</div>
	);
}

export default Save;
